<template>
    <div class="edit-view">
        <page-title>
            <el-button @click="$router.go(-1)" :disabled="saving">取消</el-button>
            <el-button @click="onDelete" :disabled="saving" type="danger" v-if="formData.id"> 删除 </el-button>
            <el-button @click="onSave" :loading="saving" type="primary">保存</el-button>
        </page-title>
        <div class="edit-view__content-wrapper">
            <div class="edit-view__content-section">
                <el-form
                    :model="formData"
                    :rules="rules"
                    ref="form"
                    label-width="108px"
                    label-position="right"
                    size="small"
                    style="max-width: 600px"
                >
                    <el-form-item prop="name" label="活动名称">
                        <el-input v-model="formData.name"></el-input>
                    </el-form-item>
                    <el-form-item prop="owner" label="铸造者">
                        <minter-select
                            v-model="formData.minterId"
                            @detail="onMinterDetail"
                            :disabled="!canEdit"
                        ></minter-select>
                    </el-form-item>
                    <el-form-item prop="cover" label="封面">
                        <single-upload v-model="formData.cover"></single-upload>
                    </el-form-item>
                    <el-form-item prop="detail" label="活动详情" style="width: calc(100vw - 450px)">
                        <rich-text v-model="formData.detail"></rich-text>
                    </el-form-item>
                    <el-form-item prop="collectionName" label="藏品名称">
                        <el-input v-model="formData.collectionName"></el-input>
                    </el-form-item>
                    <el-form-item prop="num" label="藏品数量">
                        <el-input-number type="number" v-model="formData.num"></el-input-number>
                    </el-form-item>
                    <el-form-item prop="consume" label="是否消耗藏品">
                        <el-radio v-model="formData.consume" :label="true">是</el-radio>
                        <el-radio v-model="formData.consume" :label="false">否</el-radio>
                    </el-form-item>
                    <el-form-item prop="total" label="发行数量">
                        <el-input-number type="number" v-model="formData.total"></el-input-number>
                    </el-form-item>
                    <el-form-item class="form-submit">
                        <el-button @click="onSave" :loading="saving" type="primary"> 保存 </el-button>
                        <el-button @click="onDelete" :disabled="saving" type="danger" v-if="formData.id">
                            删除
                        </el-button>
                        <el-button @click="$router.go(-1)" :disabled="saving">取消</el-button>
                    </el-form-item>
                </el-form>
            </div>
        </div>
    </div>
</template>
<script>
export default {
    name: 'MintActivityEdit',
    created() {
        if (this.$route.query.id) {
            this.$http
                .get('mintActivity/get/' + this.$route.query.id)
                .then(res => {
                    this.formData = res;
                })
                .catch(e => {
                    console.log(e);
                    this.$message.error(e.error);
                });
        }
    },
    data() {
        return {
            saving: false,
            formData: {},
            rules: {}
        };
    },
    computed: {
        canEdit() {
            return !!!this.$route.query.id;
        }
    },
    methods: {
        onSave() {
            this.$refs.form.validate(valid => {
                if (valid) {
                    this.submit();
                } else {
                    return false;
                }
            });
        },
        submit() {
            let data = { ...this.formData };

            this.saving = true;
            this.$http
                .post('/mintActivity/save', data, { body: 'json' })
                .then(res => {
                    this.saving = false;
                    this.$message.success('成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    console.log(e);
                    this.saving = false;
                    this.$message.error(e.error);
                });
        },
        onDelete() {
            this.$confirm('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/mintActivity/del/${this.formData.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error((e || {}).error || '删除失败');
                    }
                });
        },
        onMinterDetail(e) {
            console.log(e);
            this.$set(this.formData, 'minter', e.nickname);
            this.$set(this.formData, 'minterAvatar', e.avatar);
        }
    }
};
</script>
<style lang="less" scoped>
.inline-wrapper {
    .el-form-item {
        display: inline-block;
    }
}
</style>
